//
//  PlayerViewController.h
//  VclustersGemini
//
//  Created by APPLE on 2019/6/13.
//  Copyright © 2019 APPLE. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "BaseViewController.h"
#import "PlayerView.h"
#import <RCCloudPhoneSDK/RCAudioPlayer.h>
#import <RCCloudPhoneSDK/RCCommandChannel.h>
#import "PlayerControlButTipView.h"
#import "Const.h"
#import "playerShowSecretkeyView.h"
#import "uploadFileDataModel.h"
#import <RCCloudPhoneSDK/RCAudioPlayer.h>
#import <RCCloudPhoneSDK/RCRecordManager.h>
//#import <RCCloudPhoneSDK/RCCommandChannel.h>
#import <RCCloudPhoneSDK/RCLiveSteamManager.h>
#import "imageVersionRenewTipView.h"
#import "backupsFileManager.h"
#import "photosBackupsTaskModel.h"
#import "AFNetworkReachabilityManager.h"
#import "couldPhoneFileListModel.h"
#import "cloudPhoneCommonModel.h"
#import "ComontAlretViewController.h"
#import "AudioSessionObject.h"
#import "addLogObject.h"
#import "ComontAlretType2ViewController.h"
#import "customDownloadManager.h"
#import "boxDownloadFileManager.h"
#import "errorAlertTool.h"
#import "DFPlayer.h"


@class PlayerControlView;


@interface PlayerViewController : BaseViewController
{
    PlayerControlView *controlView;
    /**
     * @brief 标记是否有返回上一级
     */
    BOOL haveBack;
    
    PlayerView *mPlayerView;
    NSLock  *connectLock;
    CIImage *saveCIImage;    //保存流，取最后一张图片
    BOOL savelastImageFirst;//客户报 多次启动看到的 保存的最后一帧图没有变
    
    RCMAACPlayer *aacPlayer;
    
    UIView *wattingView;
    
    //下载nas相关
    customDownloadOperation* curDownloadmodel;
    
    BOOL needScreenShotType;/*标记需要做一次截屏*/
}

@property(copy,nonatomic)NSString * _Nullable internetVideoPort;
@property(copy,nonatomic)NSString * _Nullable ip;
@property(copy,nonatomic)NSString * _Nullable deviceId;
@property(nonatomic,assign)BOOL canControl;/*是否可以控制设备*/

@property(strong,nonatomic)PlayerControlButTipView * _Nullable PlayerControlButTipV;
/**
* @brief vpnStatus 1：开启    0：关闭
*/
@property (nonatomic, assign) NSInteger vpnStatus;

/**
* @brief internetHttp websocket指令通道连接
*/
@property (nonatomic, copy) NSString * _Nullable internetHttp;

@property (nonatomic, strong) RCLiveSteamManager * _Nullable liveStreamManager;

/**是否延迟发送打开app指令*/
@property (nonatomic, assign) BOOL               delayPostOpenAppOrder;

/**
 * @brief 编码类型是否支持h265
 */
@property(nonatomic, assign) BOOL isSupportH265Type;

/**页面跳转-需不需要回收资源*/
@property (nonatomic, assign) BOOL               isNeedRecyclResource;
@property (nonatomic, assign) BOOL               didRecyclResource;
/**音视频是否连接成功*/
@property (nonatomic, assign) BOOL               isConnectSuccess;

/**0:初始状态  1:切换云手机超分  2:token失效超分*/
@property (nonatomic, assign) NSInteger         rbdNotification;

//第一次链接设备 要发送指令信息 实现单点登录
@property (nonatomic, assign)BOOL didSendfristMsg;

@property (nonatomic, assign) BOOL isPwdVCShow;//当前是否有密码页面
//第一次链接设备 要发送指令信息 实现单点登录
@property (nonatomic, assign)BOOL isLoginAgainType;

//主动断开链接  后台之类的
@property (nonatomic, assign)BOOL needToDissconnectType;


@property(nonatomic,assign) BOOL isCodeSuspendAudioType;//手动暂停播放音乐


-(void)showNewIndicator;
-(void)removeNewIndicator;
- (void)toStopRecoder;
- (void)toStopAudioRecoder;
- (void)removeNSNotification;
- (void)addNSNotification;
- (void)initData;
- (BOOL)initVideoServer;
- (void)connectVideoServer;
- (NSArray *)getAllIvar:(id)object;

- (void)tryAgain;
- (void)requestIFrame;
- (void)disconnectVideoServer;
- (void)send_data:(NSString *)dataStr;



#pragma mark - 设置是否可以播放声音和动画
-(void)setShowImgAndVoiceTypeFun:(bool)isCan;

#pragma mark - 显示秘钥 后续忘记密码要
-(void)showSecretkeyFun;

- (void)recyclResource;
@end
