//
//  webSocketManager.h
//  双子星云手机
//
//  Created by xd h on 2024/6/20.
//

#import <Foundation/Foundation.h>
#import <RCCloudPhoneSDK/RCCommandChannel.h>
#import "AFNetworkReachabilityManager.h"
#import "backupsFileManager.h"
#import "uploadFileManager.h"
#import "downloadManager.h"
#import "downloadThumbnailManager.h"
#import "AudioSessionObject.h"
#import "commandSendCheckModel.h"
#import "RCCommandHelp.h"
#import "cloudPhoneCommonModel.h"
#import "couldPhoneBaseInfoModel.h"
#import "couldphoneSysInfoModel.h"
#import "TvStatusModel.h"
#import "couldPhoneCommonModel.h"
#import "extraMediaEventModel.h"
#import "customDownloadManager.h"
#import "boxDownloadFileManager.h"
#import "DFPlayer.h"

NS_ASSUME_NONNULL_BEGIN

@interface webSocketManager : NSObject
{
    //下载nas相关
    customDownloadOperation* curDownloadmodel;
}

+(webSocketManager *)shareInstance;
@property (nonatomic, strong) RCCommandChannelManager *commandChannelManager;//指令通道

//上传文件用到
@property (nonatomic, copy) NSString * _Nullable taskUid;
@property (nonatomic, copy) NSString * _Nullable fileName;
@property (nonatomic, strong) NSData * _Nullable AllFileData;
@property (nonatomic, strong) NSMutableArray * _Nullable cutFileDataArr;
@property (nonatomic, assign) NSInteger indexOfUploadFlie;
@property (nonatomic, assign) NSInteger cutFileEachPieceSzie;
@property (nonatomic, strong) uploadFileDataModel *curUploadFileDataMod;
@property (nonatomic, assign) BOOL isSuspendUploadType;
@property (nonatomic, assign) long curUploadPostion;//当前上次片的位置

//下载文件用到
@property (nonatomic, copy) NSString * _Nullable downloadFileTaskUid;
@property (nonatomic, strong) couldPhoneFileModel *curDownloadFileModel;
@property (nonatomic, copy) NSString * _Nullable wsDownloadSaveFilePath;//下载好的ws文件保存路径
@property (nonatomic, copy) NSString * _Nullable wsDownloadDonwPlishPath;//下载好的ws文件保存key

//备份文件用到
@property (nonatomic, copy) NSString * _Nullable backupsTaskUid;
@property (nonatomic, copy) NSString * _Nullable backupsFileName;
@property (nonatomic, strong) NSData * _Nullable backupsAllFileData;
@property (nonatomic, strong) NSMutableArray * _Nullable backupsCutFileDataArr;
@property (nonatomic, assign) NSInteger backupsIndexOfUploadFlie;
//@property (nonatomic, assign) NSInteger cutFileEachPieceSzie;
@property (nonatomic, strong) photosBackupsTaskModel *curPhotosBackupsTaskMod;
@property (nonatomic, assign) long curBackupsPostion;//当前上次片的位置

//下载缩略图用到
@property (nonatomic, copy) NSString * _Nullable downloadThumbnailTaskUid;
@property (nonatomic, strong) couldPhoneFileModel *curDownloadThumbnailModel;

//下载nas文件用到
@property (nonatomic, copy) NSString*nasFullPath;


//下载nas ws 文件 保存到文件 正在弹框中
@property (nonatomic, assign) BOOL isShowingFileDocumentPickerType;

@property(nonatomic,assign)BOOL isRebootIngType;//是否重启中
@property(nonatomic,assign)BOOL isResetingType;//是否恢复出厂中
@property(nonatomic,assign)BOOL isChangeBoxType;//是否更换盒子
@property(nonatomic,assign)BOOL isLogoutByOtherType;//被挤下线
@property(nonatomic,assign)BOOL isWaitShowLogoutAlert;//隐私模式等待被挤下线弹框是否弹出

@property(nonatomic,assign)BOOL isDiDChangePhoneSizeType;//是否修改了分辨率（如果是 进去云机需要重设解码器）

//链接websocket
- (void)opencommandChannelManagerrc_openURL;
- (void)WebSocketNeedRelinkFun;
//websocket 发消息
- (void)send_data:(NSString *)dataStr;

//创建备份文件夹
- (void)createBackupsFolderBy:(NSString*)backupsDefaultPath;
//获取备份文件夹列表
- (void)getBackupFolderListFun;
- (void)searchFileListBeginFun:(NSMutableDictionary *)dict;

#pragma mark 重启云机
- (void)needToRebootFun;
#pragma mark 恢复出厂设置云机
- (void)needToResetFun;
#pragma mark 获取云机基本信息
- (void)getBaseInfoFun;
#pragma mark 获取云机剩余空间（包含外挂磁盘）
- (void)getExtraFilesListFun;
#pragma mark 获取云机系统镜像等信息
- (void)getSysInfoFun;

#pragma mark 云机截图保存到云机图库
- (void)screenshotInCloudPhoneFun;
#pragma mark 获取TV投屏状态
- (void)getTvStatusFun;
#pragma mark 关闭TV投屏状态
- (void)offTvFun;
#pragma mark 开启TV投屏状态
- (void)onTvFun;

//上传
- (void)beginGotoUploadFileFunBy:(uploadFileDataModel *)uploadFileDataMod;
- (void)suspendUploadFileFun;
//备份
- (void)beginGotoBackupsFileFunBy:(photosBackupsTaskModel *)photosBackupsTaskMod;
//下载缩略图
- (void)begindownloadThumbnailImageFunBy:(couldPhoneFileModel *)couldPhoneFileMod;
//下载
- (void)begindownloadFileFunBy:(couldPhoneFileModel *)couldPhoneFileMod;

#pragma mark nas下载完成
- (void)NasDownloadTaskFinishedNoti:(customDownloadOperation *)nasDownloadOperation;

- (void)handleDownloadResponseFunBy:(id)message;
- (void)downloadFileFunServiceResponseFun:(NSData *)fileData with:(BOOL)isDownloadDone;
- (void)downloadThumbnailFileFunServiceResponseFun:(NSData *)fileData with:(BOOL)isDownloadDone;
#pragma mark 处理ws保存操作
- (void)saveDownDoneFileToPhoneFunBy:(NSString*)filePath withKey:(NSString *)key;
@end

NS_ASSUME_NONNULL_END
